/* vim: set ro : */

/* ******************************************************** */
/* THIS IS A GENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY */
/* ******************************************************** */

        /**
         * How we handle use deps.
         *
         * Not for end user use. Used by adjutrix and qa.
         *
         * \ingroup g_dep_list
         */
enum DepListUseOption
{
    dl_use_deps_standard,  ///< Behave as standard
    dl_use_deps_take_all,  ///< Take both sides of use conditionals except on masks
    last_dl_use_deps ///< Number of keys in paludis::DepListUseOption
};

/**
 * Write a DepListUseOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListUseOption &) PALUDIS_VISIBLE;

        /**
         * When we should upgrade.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListUpgradeOption
{
    dl_upgrade_always,  ///< Always
    dl_upgrade_as_needed,  ///< Only as needed
    last_dl_upgrade ///< Number of keys in paludis::DepListUpgradeOption
};

/**
 * Write a DepListUpgradeOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListUpgradeOption &) PALUDIS_VISIBLE;

        /**
         * Type of target being handled at the top level.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListTargetType
{
    dl_target_package,  ///< A package, so force reinstalls.
    dl_target_set,  ///< A set, so don't force reinstalls.
    last_dl_target ///< Number of keys in paludis::DepListTargetType
};

/**
 * Write a DepListTargetType to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListTargetType &) PALUDIS_VISIBLE;

        /**
         * How we should handle suggested deps.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListSuggestedOption
{
    dl_suggested_show,  ///< Show
    dl_suggested_discard,  ///< Discard
    dl_suggested_install,  ///< Install
    last_dl_suggested ///< Number of keys in paludis::DepListSuggestedOption
};

/**
 * Write a DepListSuggestedOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListSuggestedOption &) PALUDIS_VISIBLE;

        /**
         * When we should reinstall SCM packages.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListReinstallScmOption
{
    dl_reinstall_scm_never,  ///< Never
    dl_reinstall_scm_always,  ///< Always
    dl_reinstall_scm_daily,  ///< Daily
    dl_reinstall_scm_weekly,  ///< Weekly
    last_dl_reinstall_scm ///< Number of keys in paludis::DepListReinstallScmOption
};

/**
 * Write a DepListReinstallScmOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListReinstallScmOption &) PALUDIS_VISIBLE;

        /**
         * When we should reinstall.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListReinstallOption
{
    dl_reinstall_never,  ///< Never
    dl_reinstall_always,  ///< Always
    dl_reinstall_if_use_changed,  ///< If a USE flag has changed
    last_dl_reinstall ///< Number of keys in paludis::DepListReinstallOption
};

/**
 * Write a DepListReinstallOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListReinstallOption &) PALUDIS_VISIBLE;

        /**
         * When we should pull in a new slot.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListNewSlotsOption
{
    dl_new_slots_always,  ///< Always
    dl_new_slots_as_needed,  ///< Only where necessary
    last_dl_new_slots ///< Number of keys in paludis::DepListNewSlotsOption
};

/**
 * Write a DepListNewSlotsOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListNewSlotsOption &) PALUDIS_VISIBLE;

        /**
         * When we should fall back to an installed package.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListFallBackOption
{
    dl_fall_back_as_needed_except_targets,  ///< As needed, except for targets
    dl_fall_back_as_needed,  ///< As needed
    dl_fall_back_never,  ///< Never
    last_dl_fall_back ///< Number of keys in paludis::DepListFallBackOption
};

/**
 * Write a DepListFallBackOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListFallBackOption &) PALUDIS_VISIBLE;

        /**
         * State of a DepListEntry.
         *
         * \ingroup g_dep_list
         */
enum DepListEntryState
{
    dle_no_deps,  ///< Dependencies have yet to be added
    dle_has_pre_deps,  ///< Predependencies have been added
    dle_has_all_deps,  ///< All dependencies have been added
    last_dle ///< Number of keys in paludis::DepListEntryState
};

/**
 * Write a DepListEntryState to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListEntryState &) PALUDIS_VISIBLE;

/**
 * Read a DepListEntryState from a stream.
 */
std::istream &
operator>> (std::istream &, DepListEntryState &) PALUDIS_VISIBLE;

        /**
         * Kind of a DepListEntry.
         *
         * \ingroup g_dep_list
         */
enum DepListEntryKind
{
    dlk_package,  ///< A package to be installed
    dlk_subpackage,  ///< A package to be installed as part of the previous dlk_package
    dlk_already_installed,  ///< An already installed package
    dlk_virtual,  ///< A virtual package
    dlk_provided,  ///< A package provided by the previous dlk_package
    dlk_suggested,  ///< A package suggested by the previous dlk_package
    dlk_block,  ///< A blocked package that must be removed
    dlk_masked,  ///< A masked package that must be unmasked
    last_dlk ///< Number of keys in paludis::DepListEntryKind
};

/**
 * Write a DepListEntryKind to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListEntryKind &) PALUDIS_VISIBLE;

/**
 * Read a DepListEntryKind from a stream.
 */
std::istream &
operator>> (std::istream &, DepListEntryKind &) PALUDIS_VISIBLE;

        /**
         * What to do when we downgrade.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListDowngradeOption
{
    dl_downgrade_as_needed,  ///< As needed
    dl_downgrade_warning,  ///< As needed, but warn
    dl_downgrade_error,  ///< Refuse to downgrade
    last_dl_downgrade ///< Number of keys in paludis::DepListDowngradeOption
};

/**
 * Write a DepListDowngradeOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListDowngradeOption &) PALUDIS_VISIBLE;

        /**
         * How we should handle a dep class.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListDepsOption
{
    dl_deps_discard,  ///< Discard it
    dl_deps_pre,  ///< As a pre dependency
    dl_deps_pre_or_post,  ///< As a pre dependency with fallback to post
    dl_deps_post,  ///< As a post dependency
    dl_deps_try_post,  ///< As an optional post dependency
    last_dl_deps ///< Number of keys in paludis::DepListDepsOption
};

/**
 * Write a DepListDepsOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListDepsOption &) PALUDIS_VISIBLE;

        /**
         * How we should handle circular deps.
         *
         * \see DepListOptions
         * \ingroup g_dep_list
         */
enum DepListCircularOption
{
    dl_circular_error,  ///< As an error
    dl_circular_discard,  ///< Discard them
    dl_circular_discard_silently,  ///< Discard them silently
    last_dl_circular ///< Number of keys in paludis::DepListCircularOption
};

/**
 * Write a DepListCircularOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListCircularOption &) PALUDIS_VISIBLE;

        /**
         * How we handle blocks.
         *
         * \ingroup g_dep_list
         */
enum DepListBlocksOption
{
    dl_blocks_accumulate,  ///< Accumulate them and show all errors together
    dl_blocks_error,  ///< Error on the first one
    dl_blocks_discard,  ///< Discard (dangerous)
    dl_blocks_discard_completely,  ///< Discard completely (not for user visible use)
    last_dl_blocks ///< Number of keys in paludis::DepListBlocksOption
};

/**
 * Write a DepListBlocksOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const DepListBlocksOption &) PALUDIS_VISIBLE;

