/* vim: set ro : */

/* ******************************************************** */
/* THIS IS A GENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY */
/* ******************************************************** */

        /**
         * Boolean options for Merger, used by MergerOptions
         *
         * \ingroup g_repository
         * \since 0.26
         */
enum MergerOption
{
    mo_rewrite_symlinks,  ///< Fix symlinks that point into the image directory (otherwise throw an error)
    mo_allow_empty_dirs,  ///< Allow merging empty directories
    last_mo ///< Number of keys in paludis::MergerOption
};

/**
 * Write a MergerOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const MergerOption &) PALUDIS_VISIBLE;

/**
 * Read a MergerOption from a stream.
 */
std::istream &
operator>> (std::istream &, MergerOption &) PALUDIS_VISIBLE;

        /**
         * Status flags for Merger, used by MergeStatusFlags
         *
         * \ingroup g_repository
         * \since 0.26
         */
enum MergeStatusFlag
{
    msi_unlinked_first,  ///< We unlinked before the merge
    msi_rename,  ///< We renamed rather than copied
    msi_parent_rename,  ///< A parent directory was renamed, so we weren't copied
    msi_used_existing,  ///< We used the existing entry (e.g. dir over dir)
    msi_fixed_ownership,  ///< We fixed owner or group from the reduced id
    msi_setid_bits,  ///< The source file had set*id bits
    msi_xattr,  ///< The source file had xattr bits
    msi_as_hardlink,  ///< We detected a hardlink and merged it as such
    last_msi ///< Number of keys in paludis::MergeStatusFlag
};

/**
 * Write a MergeStatusFlag to a stream.
 */
std::ostream &
operator<< (std::ostream &, const MergeStatusFlag &) PALUDIS_VISIBLE;

